#include <cstdio>
#include <vector>

#define maxN 512
#define maxV (1<<20)

using namespace std;

vector < vector <int> > list;
vector < vector < pair <int,int> > > used;
int A[maxN][maxN];
char bad[maxN];
vector < int > spir, spir1;
int m,n,a,b,fr,to;
int nn;

void input()
{
     int i,j,t;
     scanf("%d%d",&m,&n);
     list.resize(m);
     used.resize(n+1);
     for (i=0;i<m;++i) {
         scanf("%d",&t);
         list[i].resize(t);
         for (j=0;j<t;++j) scanf("%d",&list[i][j]);
         }
     scanf("%d%d%d%d",&a,&b,&fr,&to);
     spir.push_back(to);
     spir1.push_back(fr);
}

void build()
{
     int i,j,k,p,q;
     for (i=0;i<m;++i)
         for (j=0;j<list[i].size();++j) used[list[i][j]].push_back(make_pair(i,j));
     nn = n;
     for (i=0;i<maxN;++i) for (j=0;j<maxN;++j) A[i][j] = maxV;
     for (i=0;i<m;++i) 
         for (j=0;j<list[i].size()-1;++j) A[list[i][j]][list[i][j+1]] = A[list[i][j+1]][list[i][j]] = a;
     for (i=1;i<=n;++i) if (used[i].size() > 1) {
         bad[i] = 1;
         for (j=0;j<used[i].size();++j) {
             if (used[i][j].second > 0) A[list[used[i][j].first][used[i][j].second-1]][nn+j+1] = A[nn+j+1][list[used[i][j].first][used[i][j].second-1]] = a;
             if (used[i][j].second < list[used[i][j].first].size()-1) A[list[used[i][j].first][used[i][j].second+1]][nn+j+1] = A[nn+j+1][list[used[i][j].first][used[i][j].second+1]] = a;
             }
         for (p=nn+1;p<=nn+used[i].size();++p)
             for (q=nn+1;q<=nn+used[i].size();++q) if (p != q) A[p][q] = A[q][p] = b;
         if (i == to) for (p=nn+1;p<=nn+used[i].size();++p) spir.push_back(p);
         if (i == fr) for (p=nn+1;p<=nn+used[i].size();++p) spir1.push_back(p);
         nn += used[i].size();
         }
}

void solve()
{
     int i,j,k,min = maxV;
     for (i=0;i<=maxN;++i) A[i][i] = 0;
     for (k=1;k<=nn;++k) if (!bad[k])
         for (i=1;i<=nn;++i) if (!bad[i])
             for (j=1;j<=nn;++j) if (!bad[j])
                 if (A[i][k] + A[k][j] < A[i][j]) A[i][j] = A[i][k] + A[k][j];
     for (i=0;i<spir1.size();++i) 
         for (j=0;j<spir.size();++j)
             if (min > A[spir1[i]][spir[j]]) min = A[spir1[i]][spir[j]];
     printf("%d\n",min);
}

void debug()
{
     int i,j;
     for (i=1;i<=nn;++i) {
         for (j=1;j<=nn;++j) printf("%4d",A[i][j]);
         printf("\n");
         }
}

int main()
{
    input();
    build();
    //debug();
    solve();
    return 0;
}
