// Iordan Boev SMG
# include <stdio.h>
# define MAXN (1<<7)
# define MAXM (1<<7)
# define max(a,b) (((a) > (b)) ? (a) : (b))

int n,m,ans;
int data[MAXN][MAXM];
int table[MAXN][MAXM];

void read() {
     scanf("%d %d", &n,&m);
     for(int i = 1; i <= n; i++) {
         for(int j = 1; j <= m; j++) {
             scanf("%d", &data[i][j]);        
             table[i][j] = 0;
         }            
     }            
}

int exist(int a,int b) {
    if(a >=1 && a <=n && b>= 1&& b <= m) return 1;
    return 0;    
}

int f(int p,int q) {
    if(table[p][q] != 0) return table[p][q];     
    int maxans = 0;
    if(exist(p-2,q-1) && data[p-2][q-1] > data[p][q]) {
        table[p-2][q-1] = f(p-2,q-1);
        maxans = max(maxans,table[p-2][q-1]);                                                                
    }
    if(exist(p-2,q+1) && data[p-2][q+1] > data[p][q]) {
        table[p-2][q+1] = f(p-2,q+1);
        maxans = max(maxans,table[p-2][q+1]);                                                                
    }
    if(exist(p-1,q+2) && data[p-1][q+2] > data[p][q]) {
        table[p-1][q+2] = f(p-1,q+2);
        maxans = max(maxans,table[p-1][q+2]);                                                                
    }
    if(exist(p+1,q+2) && data[p+1][q+2] > data[p][q]) {
        table[p+1][q+2] = f(p+1,q+2);
        maxans = max(maxans,table[p+1][q+2]);                                                                
    }
    if(exist(p+2,q+1) && data[p+2][q+1] > data[p][q]) {
        table[p+2][q+1] = f(p+2,q+1);
        maxans = max(maxans,table[p+2][q+1]);                                                                
    }
    if(exist(p+2,q-1) && data[p+2][q-1] > data[p][q]) {
        table[p+2][q-1] = f(p+2,q-1);
        maxans = max(maxans,table[p+2][q-1]);                                                                
    }
    if(exist(p+1,q-2) && data[p+1][q-2] > data[p][q]) {
        table[p+1][q-2] = f(p+1,q-2);
        maxans = max(maxans,table[p+1][q-2]);                                                                
    }
    if(exist(p-1,q-2) && data[p-1][q-2] > data[p][q]) {
        table[p-1][q-2] = f(p-1,q-2);
        maxans = max(maxans,table[p-1][q-2]);                                                                
    }
    return (maxans+data[p][q]);   
}

void solve() {
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            if(table[i][j] == 0) table[i][j] = f(i,j);
        }            
    }
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            ans = max(ans,table[i][j]);        
        }            
    }     
    printf("%d\n", ans);       
}

int main () {
    read();   
    solve();    
    return 0;
}
