#include <iostream>
#include <set>
using namespace std;

int G[10000][8], cnt[100000];
int M[10000];
int m, n;
int mx[8] = { 1,  2,  2,  1, -1, -2, -2, -1};
int my[8] = {-2, -1,  1,  2,  2,  1, -1, -2};
int in[10000];

class Vertex
{
       public:
       int key;
       Vertex(){}
       Vertex(int a){key = a;}
       bool operator<(Vertex V) const
       {
            if (in[key] != in[V.key])
             return in[key] < in[V.key];
            return key < V.key;
       }
};

set<Vertex> heap;
int D[10000];

int main()
{
    cin >> n >> m;
    for (int i = 0; i < n; i++)
     for (int j = 0; j < m; j++)
     {
         cin >> M[100*i + j];
         D[100*i + j] = M[100*i + j];
     }

    for (int i = 0; i < n; i++)
     for (int j = 0; j < m; j++)
      for (int k = 0; k < 8; k++)
      {
          int newi = i + mx[k];
          int newj = j + my[k];
          if (newi < 0 || newi >= n || newj < 0 || newj >= m) continue;
          if (M[100*newi + newj] > M[100*i + j])
          {
               G[100*i + j][ cnt[100*i + j]++ ] = 100*newi + newj;
               in[100*newi + newj]++;
          }          
      }
      
    for (int i = 0; i < n; i++)
     for (int j = 0; j < m; j++)
      heap.insert(Vertex(100*i + j));   
    
    for (int k = 0; k < m*n; k++)
    {
        set<Vertex>::iterator v = heap.begin();
        for (int i = 0; i < cnt[v->key]; i++)
        {
            set<Vertex>::iterator it;
            it = heap.find( G[v->key][i] );
            Vertex t = *it;
            heap.erase(it);
            
            in[t.key]--;
            heap.insert(Vertex(t.key));
            if (D[t.key] < D[v->key] + M[t.key]) D[t.key] = D[v->key] + M[t.key];
       }
       heap.erase(heap.begin());
    }
    
    int maxx = 0;
    for (int i = 0; i < 10000; i++)
     maxx = max(D[i], maxx);
    
    cout << maxx << endl;
    return 0;
}
