#include <iostream>
using namespace std;

int dx[8] = { -2, -2, -1, -1,  1, 1,  2, 2 };
int dy[8] = { -1,  1, -2,  2, -2, 2, -1, 1 };

const int MAX = 1024;
int a[MAX][MAX];
int s[MAX][MAX];
int m,n;

void compute(int i,int j)
{ s[i][j]=0;
  for(int k=0; k<8; k++)
     { int i1 = i + dx[k];
	     int j1 = j + dy[k];
	     if(0<=i1 && i1<m && 0<=j1 && j1<n)
         if(a[i][j]<a[i1][j1])
         { if(s[i1][j1]==-1) compute(i1,j1);
           if(s[i][j] < s[i1][j1]) s[i][j] = s[i1][j1];
         } 
      } 
  s[i][j] += a[i][j];
}

int main()
{
  cin >> m >> n;
  for(int i=0; i<m; i++)
    for(int j=0; j<n; j++)
    {  cin >> a[i][j];
       s[i][j]=-1;
    }   
    
  int maxs = -1;  
  for(int i=0; i<m; i++)
    for(int j=0; j<n; j++)
    { if(s[i][j]==-1) compute(i,j);
      if(maxs < s[i][j]) maxs = s[i][j];
    }

/*    
  for(int i=0; i<m; i++)
  { for(int j=0; j<n; j++)
      cout << s[i][j] << " ";
    cout << endl;
  }
*/
  
  cout << maxs << endl;   
  return 0;
}
