#include <iostream>
#include <set>

#define MP make_pair
#define f first
#define s second

#define INF 1<<30

using namespace std;

int m,n,ro[32][128],t,pr,a,b,fs,ls,last[128];
pair<int,pair<int,int> > g[128][128];

set<pair<int,pair<int,int> > > s;
int dist[128];
int dijkstra(int st,int end)
{
	for(int i=1;i<=n;i++)
		dist[i]=INF;
	dist[st]=0;
	for(int i=1;i<=last[st];i++)
		s.insert(g[st][i]);
	while(!s.empty())
	{
		pair<int,pair<int,int> > cur=*s.begin();
		int to=cur.s.f;
		int len=cur.f;
		int line=cur.s.s;
//		cout<<len<<" "<<to<<"\n";
		if(to==end)
			return len;
		s.erase(s.begin());
		if(dist[to]>len)
			dist[to]=len;
		for(int i=1;i<=last[to];i++)
		{
			if(dist[to]+g[to][i].f+(g[to][i].s.s!=line)*b<dist[g[to][i].s.f])
			{
				dist[g[to][i].s.f]=dist[to]+g[to][i].f+(g[to][i].s.s!=line)*b;
				s.insert(MP(dist[g[to][i].s.f],MP(g[to][i].s.f,g[to][i].s.s)));
			}
		}
	}
	cout<<"-1\n";
	exit(0);
}
int main()
{
	cin>>m>>n;
	for(int i=1;i<=m;i++)
	{
		cin>>ro[i][0];
		for(int j=1;j<=ro[i][0];j++)
			cin>>ro[i][j];
	}
	cin>>a>>b;
	cin>>fs>>ls;
	for(int i=1;i<=m;i++)
		for(int j=2;j<=ro[i][0];j++)
		{
			g[ro[i][j]][  ++last[ro[i][j]]  ]=MP(a,MP(ro[i][j-1],i));
			g[ro[i][j-1]][  ++last[ro[i][j-1]]  ]=MP(a,MP(ro[i][j],i));
		}
/*	for(int i=1;i<=n;i++)
	{
		for(int j=1;j<=last[i];j++)
			cout<<g[i][j].s.f<<" ";
		cout<<"\n";
	} */
	cout<<dijkstra(fs,ls)<<"\n";
/*	for(int i=1;i<=n;i++)
		cout<<dist[i]<<" ";
	cout<<"\n"; */
    return 0;
}
