#include <cstdio>
#include <vector>
#define pb push_back
using namespace std;

const int BUS = 1 << 5;
const int STOP = 1 << 7;
const int INF = 99999999;
int i, j, N, M, A, B, beg, end;

vector < vector <int> > a;
bool u[BUS][STOP];
int D[BUS][STOP];
int pos[BUS][STOP];

void solve () {
	int v = beg, bus, nv, nbus, mm;
	//memset (D, INF, sizeof (D));
	for (i = 1; i <= M; i++) for (j = 1; j <= N; j++) D[i][j] = INF;
	for (i = 1; i <= M; i++) if (pos[i][beg] != 0) {D[i][beg] = 0; bus = i;}
	
	while (1) {
		u[bus][v] = 1;
		for (i = 1; i <= M; i++) // prehvyrlqne na druga liniq
			if (bus != i && pos[i][v] != 0) {
				nv = v;
				nbus = i;
				if (D[nbus][nv] > D[bus][v] + B)
					D[nbus][nv] = D[bus][v] + B;
			}
		nbus = bus;
		if (pos[bus][v] > 1) { //nazad
			nv = a[bus][pos[bus][v] - 1];
			if (D[nbus][nv] > D[bus][v] + A)
				D[nbus][nv] = D[bus][v] + A;
		}

		if (pos[bus][v] < a[bus][0]) { //napred
			nv = a[bus][pos[bus][v] + 1];
			if (D[nbus][nv] > D[bus][v] + A)
					D[nbus][nv] = D[bus][v] + A;
		}
		
		//find min
		mm = INF;
		for (i = 1; i <= M; i++)
			for (j = 1; j <= N; j++)
				if (D[i][j] < mm && !u[i][j]) {
					bus = i;
					v = j;
					mm = D[i][j];
				}
		if (mm == INF) break;
	}
	
/*	for (i = 1; i <= M; i++) {
		for (j = 1; j <= N; j++) {		
 			if (D[i][j] != INF) printf ("(%d)%d ", j, D[i][j]);
 			//else printf ("(%d)%d ", j, -1);
 		}
 		printf ("\n");
 	}*/
 	mm = INF;
 	for (i = 1; i <= M; i++) if (D[i][end] < mm) mm = D[i][end];
 	if (mm == INF) printf ("-1\n");
 	else printf ("%d\n", mm);
}

int main () {
	//freopen ("inp.txt", "rt", stdin);
	scanf ("%d %d", &M, &N);
	a.resize (M + 3);
	int t, v;
	for (i = 1; i <= M; i++) {
		scanf ("%d", &t); a[i].pb (t);
		for (j = 1; j <= t; j++) {
			scanf ("%d", &v);
			a[i].pb (v);
		}
	}
	scanf ("%d %d", &A, &B);
	scanf ("%d %d", &beg, &end);
 	for (i = 1; i <= M; i++) {
 		for (j = 1; j <= a[i][0]; j++) {
 			
 			pos[i][a[i][j]] = j;
 			//printf ("%d(%d) ", a[i][j], pos[i][a[i][j]]);
 		}
 		//printf ("\n");
 	}
 	solve ();
	return 0;
}
