#include <cstdio>
#include <algorithm>

const int MAXN = 1 << 8;

int i, j, n, m;
int a[MAXN][MAXN];
bool u[MAXN][MAXN], U[MAXN][MAXN];
int d;

int mx[] = {0,-2,-1,1,2,2,1,-1,-2};
int my[] = {0,1,2,2,1,-1,-2,-2,-1};
int temp, br;
int ans;

bool check (int x, int y, int nx, int ny) {
	if (nx < 1 || nx > n || ny < 1 || ny > m || u[nx][ny]) return 0;
	if (a[x][y] <= a[nx][ny]) return 0;
	return 1;
}

void dfs (int x, int y) {
	u[x][y] = 1;
	d += a[x][y];
	ans = std::max (ans, d);
	int ii;
	for (ii = 1; ii <= 8; ii++) {
		if (check (x, y, x + mx[ii], y + my[ii])) {
			dfs (x + mx[ii], y + my[ii]);
		}
	}
	u[x][y] = 0;
	d -= a[x][y];
}

int main () {
	//freopen ("walk.inp", "rt", stdin);
	scanf ("%d%d", &n, &m);
	for (i = 1; i <= n; i++) for (j = 1; j <= m; j++) scanf ("%d", &a[i][j]);
	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++){
			dfs (i, j);
		}
	printf ("%d\n", ans);
}
